import java.io.*;
import java.util.*;
import java.util.regex.*;

        class ExprLALR1
        {
                YYARec[] yya;
                YYARec[] yyg;
                YYRRec[] yyr;
                int[] yyd;
                int[] yyal;
                int[] yyah;
                int[] yygl;
                int[] yygh;

                int yyn = 0;
                int yystate = 0;
                int yychar = -1;
                int yynerrs = 0;
                int yyerrflag = 0;
                int yysp = 0;
                int yymaxdepth = 1024;
                int yyflag = 0;
                int yyfnone   = 0;
                int[] yys = new int[1024];
                String[] yyv = new String[1024];

                String yyval = "";

                public static class TOutput extends PrintWriter { 
                 public TOutput(OutputStreamWriter o) { super(o); }
                 public TOutput(BufferedWriter b) { super(b); }
                 public TOutput(PrintStream s) { super(s); }
                 public void WriteLine(String s) { println(s); } 
                }
                TOutput Output;

                class YYARec
                {
                        public int sym;
                        public int act;
                        public YYARec (int s, int a){ sym = s; act = a; }
                }

                class YYRRec
                {
                        public int len;
                        public int sym;
                        public YYRRec (int l, int s){ sym = s; len = l; }
                }

                ////////////////////////////////////////////////////////////////
                /// Constant values / tokens
                ////////////////////////////////////////////////////////////////
                int t_plus = 257;
                int t_minus = 258;
                int t_times = 259;
                int t_div = 260;
                int t_leftPar = 261;
                int t_rightPar = 262;
                int t_ident = 263;
                int t_number = 264;
                int t_ignore = 256;
///////////////////////////////////////////////////////////
/// Global settings: 
///////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////


                /// <summary>
                /// Der Haupteinstiegspunkt fr die Anwendung.
                /// </summary>
                public static void main(String[] args)
                {
                        ExprLALR1 compiler = new ExprLALR1();
                        String inputstream = "";

                        boolean ShowTokens = false;
                        String InputFilename = "";
                        String OutputFilename = "";

                        for (String s : args)
                        {
                                if (s.toLowerCase().equals("-t"))
                                {
                                        ShowTokens = true;
                                }
                                else
                                {
                                        if (InputFilename.equals(""))  InputFilename = s; else
                                        if (OutputFilename.equals("")) OutputFilename = s; else
                                        {
                                                System.out.println("Too many arguments!");
                                                System.exit(1);
                                        }
                                }
                        }
                        if (InputFilename.equals(""))
                        {
                                System.out.println("You need to specify input and outputfile: compiler.exe input.txt output.txt");
                                System.exit(1);
                        }

                        try{

						FileInputStream in=new FileInputStream(InputFilename);
						int len=in.available();
						for(int i=1;i<=len;i++)
						{
						   inputstream += (char)in.read();
						}
                        in.close();

                        ////////////////////////////////////////////////////////////////
                        /// Compiler Code:
                        ////////////////////////////////////////////////////////////////

			

                        compiler.Output = null;
                        if (!OutputFilename.equals(""))
                        {
                                File myFile = new File(OutputFilename);
                                myFile.delete();
                                
                                compiler.Output = new TOutput(new BufferedWriter(new OutputStreamWriter(new FileOutputStream(OutputFilename),"UTF8")));
                        }
                        else
                        {
								try {
									compiler.Output = new TOutput(new OutputStreamWriter(System.out, "UTF8"));
								} catch (UnsupportedEncodingException error) {
	                                compiler.Output = new TOutput(System.out);
								}
                        }
                        }catch (Exception e) {e.printStackTrace(); System.exit(1);}

                        if (!compiler.Scanner(inputstream)) System.exit(1);
                        if (ShowTokens)
                        {
                                for (Object o : compiler.TokenList)
                                {
                                        AToken t = (AToken)o;
                                        System.out.println("TokenID: "+t.token+"  =  "+t.val);
                                }
                        }
                        compiler.InitTables();
                        if(!compiler.yyparse()) System.exit(1);

                        if (compiler.Output != null) compiler.Output.close();			
                }
                public void yyaction (int yyruleno)
                {
                        switch (yyruleno)
                        {
                                ////////////////////////////////////////////////////////////////
                                /// YYAction code:
                                ////////////////////////////////////////////////////////////////
							case    1 : 
         yyval = yyv[yysp-1] + yyv[yysp-0];
         //Output.WriteLine(yyval);
         
       break;
							case    2 : 
         yyval = yyv[yysp-2] + yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case    3 : 
         yyval = yyv[yysp-2] + yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case    4 : 
         yyval = "";
         
       break;
							case    5 : 
         yyval = yyv[yysp-0];
         
       break;
							case    6 : 
         yyval = yyv[yysp-0];
         
       break;
							case    7 : 
         yyval = yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case    8 : 
         yyval = yyv[yysp-2] + yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case    9 : 
         yyval = "";
         
       break;
							case   10 : 
         yyval = yyv[yysp-0];
         
       break;
							case   11 : 
         yyval = yyv[yysp-0];
         
       break;
							case   12 : 
         yyval = yyv[yysp-2] + yyv[yysp-1] + yyv[yysp-0];
         
       break;
							case   13 : 
         yyval = yyv[yysp-0];
         
       break;
							case   14 : 
         yyval = yyv[yysp-0];
         
       break;
                                default : return;
                        }
                }

                public void InitTables()
                {
                        ////////////////////////////////////////////////////////////////
                        /// Init Table code:
                        ////////////////////////////////////////////////////////////////

					int yynacts   = 45;
					int yyngotos  = 23;
					int yynstates = 24;
					int yynrules  = 14;
					yya = new YYARec[yynacts+1];  int yyac = 1;
					yyg = new YYARec[yyngotos+1]; int yygc = 1;
					yyr = new YYRRec[yynrules+1]; int yyrc = 1;

					yya[yyac] = new YYARec(257,5);yyac++; 
					yya[yyac] = new YYARec(258,6);yyac++; 
					yya[yyac] = new YYARec(261,7);yyac++; 
					yya[yyac] = new YYARec(263,8);yyac++; 
					yya[yyac] = new YYARec(264,9);yyac++; 
					yya[yyac] = new YYARec(259,12);yyac++; 
					yya[yyac] = new YYARec(260,13);yyac++; 
					yya[yyac] = new YYARec(0,-9 );yyac++; 
					yya[yyac] = new YYARec(257,-9 );yyac++; 
					yya[yyac] = new YYARec(258,-9 );yyac++; 
					yya[yyac] = new YYARec(262,-9 );yyac++; 
					yya[yyac] = new YYARec(261,7);yyac++; 
					yya[yyac] = new YYARec(263,8);yyac++; 
					yya[yyac] = new YYARec(264,9);yyac++; 
					yya[yyac] = new YYARec(257,5);yyac++; 
					yya[yyac] = new YYARec(258,6);yyac++; 
					yya[yyac] = new YYARec(0,-4 );yyac++; 
					yya[yyac] = new YYARec(262,-4 );yyac++; 
					yya[yyac] = new YYARec(0,0);yyac++; 
					yya[yyac] = new YYARec(257,5);yyac++; 
					yya[yyac] = new YYARec(258,6);yyac++; 
					yya[yyac] = new YYARec(261,7);yyac++; 
					yya[yyac] = new YYARec(263,8);yyac++; 
					yya[yyac] = new YYARec(264,9);yyac++; 
					yya[yyac] = new YYARec(261,7);yyac++; 
					yya[yyac] = new YYARec(263,8);yyac++; 
					yya[yyac] = new YYARec(264,9);yyac++; 
					yya[yyac] = new YYARec(257,5);yyac++; 
					yya[yyac] = new YYARec(258,6);yyac++; 
					yya[yyac] = new YYARec(0,-4 );yyac++; 
					yya[yyac] = new YYARec(262,-4 );yyac++; 
					yya[yyac] = new YYARec(261,7);yyac++; 
					yya[yyac] = new YYARec(263,8);yyac++; 
					yya[yyac] = new YYARec(264,9);yyac++; 
					yya[yyac] = new YYARec(262,21);yyac++; 
					yya[yyac] = new YYARec(259,12);yyac++; 
					yya[yyac] = new YYARec(260,13);yyac++; 
					yya[yyac] = new YYARec(0,-9 );yyac++; 
					yya[yyac] = new YYARec(257,-9 );yyac++; 
					yya[yyac] = new YYARec(258,-9 );yyac++; 
					yya[yyac] = new YYARec(262,-9 );yyac++; 
					yya[yyac] = new YYARec(257,5);yyac++; 
					yya[yyac] = new YYARec(258,6);yyac++; 
					yya[yyac] = new YYARec(0,-4 );yyac++; 
					yya[yyac] = new YYARec(262,-4 );yyac++;

					yyg[yygc] = new YYARec(-6,1);yygc++; 
					yyg[yygc] = new YYARec(-5,2);yygc++; 
					yyg[yygc] = new YYARec(-3,3);yygc++; 
					yyg[yygc] = new YYARec(-2,4);yygc++; 
					yyg[yygc] = new YYARec(-8,10);yygc++; 
					yyg[yygc] = new YYARec(-7,11);yygc++; 
					yyg[yygc] = new YYARec(-6,1);yygc++; 
					yyg[yygc] = new YYARec(-3,14);yygc++; 
					yyg[yygc] = new YYARec(-5,15);yygc++; 
					yyg[yygc] = new YYARec(-4,16);yygc++; 
					yyg[yygc] = new YYARec(-6,1);yygc++; 
					yyg[yygc] = new YYARec(-5,2);yygc++; 
					yyg[yygc] = new YYARec(-3,3);yygc++; 
					yyg[yygc] = new YYARec(-2,17);yygc++; 
					yyg[yygc] = new YYARec(-6,18);yygc++; 
					yyg[yygc] = new YYARec(-5,15);yygc++; 
					yyg[yygc] = new YYARec(-4,19);yygc++; 
					yyg[yygc] = new YYARec(-6,1);yygc++; 
					yyg[yygc] = new YYARec(-3,20);yygc++; 
					yyg[yygc] = new YYARec(-8,10);yygc++; 
					yyg[yygc] = new YYARec(-7,22);yygc++; 
					yyg[yygc] = new YYARec(-5,15);yygc++; 
					yyg[yygc] = new YYARec(-4,23);yygc++;

					yyd = new int[yynstates];
					yyd[0] = 0;  
					yyd[1] = 0;  
					yyd[2] = 0;  
					yyd[3] = 0;  
					yyd[4] = 0;  
					yyd[5] = -5;  
					yyd[6] = -6;  
					yyd[7] = 0;  
					yyd[8] = -13;  
					yyd[9] = -14;  
					yyd[10] = 0;  
					yyd[11] = -7;  
					yyd[12] = -10;  
					yyd[13] = -11;  
					yyd[14] = 0;  
					yyd[15] = 0;  
					yyd[16] = -1;  
					yyd[17] = 0;  
					yyd[18] = 0;  
					yyd[19] = -2;  
					yyd[20] = 0;  
					yyd[21] = -12;  
					yyd[22] = -8;  
					yyd[23] = -3; 

					yyal = new int[yynstates];
					yyal[0] = 1;  
					yyal[1] = 6;  
					yyal[2] = 12;  
					yyal[3] = 15;  
					yyal[4] = 19;  
					yyal[5] = 20;  
					yyal[6] = 20;  
					yyal[7] = 20;  
					yyal[8] = 25;  
					yyal[9] = 25;  
					yyal[10] = 25;  
					yyal[11] = 28;  
					yyal[12] = 28;  
					yyal[13] = 28;  
					yyal[14] = 28;  
					yyal[15] = 32;  
					yyal[16] = 35;  
					yyal[17] = 35;  
					yyal[18] = 36;  
					yyal[19] = 42;  
					yyal[20] = 42;  
					yyal[21] = 46;  
					yyal[22] = 46;  
					yyal[23] = 46; 

					yyah = new int[yynstates];
					yyah[0] = 5;  
					yyah[1] = 11;  
					yyah[2] = 14;  
					yyah[3] = 18;  
					yyah[4] = 19;  
					yyah[5] = 19;  
					yyah[6] = 19;  
					yyah[7] = 24;  
					yyah[8] = 24;  
					yyah[9] = 24;  
					yyah[10] = 27;  
					yyah[11] = 27;  
					yyah[12] = 27;  
					yyah[13] = 27;  
					yyah[14] = 31;  
					yyah[15] = 34;  
					yyah[16] = 34;  
					yyah[17] = 35;  
					yyah[18] = 41;  
					yyah[19] = 41;  
					yyah[20] = 45;  
					yyah[21] = 45;  
					yyah[22] = 45;  
					yyah[23] = 45; 

					yygl = new int[yynstates];
					yygl[0] = 1;  
					yygl[1] = 5;  
					yygl[2] = 7;  
					yygl[3] = 9;  
					yygl[4] = 11;  
					yygl[5] = 11;  
					yygl[6] = 11;  
					yygl[7] = 11;  
					yygl[8] = 15;  
					yygl[9] = 15;  
					yygl[10] = 15;  
					yygl[11] = 16;  
					yygl[12] = 16;  
					yygl[13] = 16;  
					yygl[14] = 16;  
					yygl[15] = 18;  
					yygl[16] = 20;  
					yygl[17] = 20;  
					yygl[18] = 20;  
					yygl[19] = 22;  
					yygl[20] = 22;  
					yygl[21] = 24;  
					yygl[22] = 24;  
					yygl[23] = 24; 

					yygh = new int[yynstates];
					yygh[0] = 4;  
					yygh[1] = 6;  
					yygh[2] = 8;  
					yygh[3] = 10;  
					yygh[4] = 10;  
					yygh[5] = 10;  
					yygh[6] = 10;  
					yygh[7] = 14;  
					yygh[8] = 14;  
					yygh[9] = 14;  
					yygh[10] = 15;  
					yygh[11] = 15;  
					yygh[12] = 15;  
					yygh[13] = 15;  
					yygh[14] = 17;  
					yygh[15] = 19;  
					yygh[16] = 19;  
					yygh[17] = 19;  
					yygh[18] = 21;  
					yygh[19] = 21;  
					yygh[20] = 23;  
					yygh[21] = 23;  
					yygh[22] = 23;  
					yygh[23] = 23; 

					yyr[yyrc] = new YYRRec(2,-2);yyrc++; 
					yyr[yyrc] = new YYRRec(3,-2);yyrc++; 
					yyr[yyrc] = new YYRRec(3,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(0,-4);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-5);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-5);yyrc++; 
					yyr[yyrc] = new YYRRec(2,-3);yyrc++; 
					yyr[yyrc] = new YYRRec(3,-7);yyrc++; 
					yyr[yyrc] = new YYRRec(0,-7);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-8);yyrc++; 
					yyr[yyrc] = new YYRRec(3,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++; 
					yyr[yyrc] = new YYRRec(1,-6);yyrc++;
                }

                public boolean yyact(int state, int sym)
                {
                        int k = yyal[state];
                        while ( k <= yyah[state] && yya[k].sym != sym) k++;
                        if (k > yyah[state]) return false;
                        yyn = yya[k].act;
                        return true;
                }
                public boolean yygoto(int state, int sym)
                {
                        int k = yygl[state];
                        while ( k <= yygh[state] && yyg[k].sym != sym) k++;
                        if (k > yygh[state]) return false;
                        yyn = yyg[k].act;
                        return true;
                }

                public void yyerror (String s)
                {
						if (Output != null) Output.WriteLine(s);
                        System.out.println(s);
                }

                int yylexpos = -1;
                String yylval = "";

                public int yylex ()
                {
                        yylexpos++;
                        if(yylexpos >= TokenList.size())
                        {
                                yylval = "";
                                return 0;
                        }
                        else
                        {
                                yylval = ((AToken)TokenList.get(yylexpos)).val;
                                return ((AToken)TokenList.get(yylexpos)).token;
                        }
                }


                public boolean yyparse ()
                {
                        boolean jumpToNext = false;
                        while(true){ // Parse:
                        if (!jumpToNext){
                        yysp++;
                        if (yysp>yymaxdepth)
                        {
                                yyerror("yyparse stack overflow");
                                return false;
                        }

                        yys[yysp] = yystate;
                        yyv[yysp] = yyval;
                        }
                        jumpToNext = false;

                        if (yyd[yystate]==0 && yychar==-1)
                        {
                            yychar = yylex();
                            if (yychar<0) yychar = 0;
                        }

                        yyn = yyd[yystate];
                        if (yyn != 0) {
                         /// reduce:
                         yyflag = yyfnone;
                         yyaction(-yyn);
                         yysp -= yyr[-yyn].len;
                         if (yygoto(yys[yysp], yyr[-yyn].sym)) yystate = yyn;
                         switch (yyflag)
                         {
                                 case 1 : return true;
                                 case 2 : return false;
                                 case 3 : {
                                   int r = yy_errlab();
                                   if (r == 0) return false;
                                   if (r == 1) continue;
                                   if (r == 2) {jumpToNext = true; continue; }
                                 }
                         }
                         continue; // PARSE:
                         ///////////////
                        }

                        if (! yyact(yystate, yychar)) {
                          if (yyerrflag==0) yyerror("syntax error");
                          int r = yy_errlab();
                          if (r == 0) return false;
                          if (r == 1) continue;
                          if (r == 2) {jumpToNext = true; continue; }
                        }
                        else if (yyn>0) {
                         /// shift:
                         yystate = yyn;
                         yychar = -1;
                         yyval = yylval;
                         if (yyerrflag>0) yyerrflag--;
                         continue; // PARSE:
                         ///////////////
                        }
                        else if (yyn<0) {
                         /// reduce:
                         yyflag = yyfnone;
                         yyaction(-yyn);
                         yysp -= yyr[-yyn].len;
                         if (yygoto(yys[yysp], yyr[-yyn].sym)) yystate = yyn;
                         switch (yyflag)
                         {
                                 case 1 : return true;
                                 case 2 : return false;
                                 case 3 : {
                                   int r = yy_errlab();
                                   if (r == 0) return false;
                                   if (r == 1) continue;
                                   if (r == 2) {jumpToNext = true; continue; }
                                 }
                         }
                         continue; // PARSE:
                         ///////////////
                        }
                        else return true;
                        } // WHILE Parse:
                }

                public int yy_errlab (){
                        if (yyerrflag==0) yynerrs++;
                        if (yyerrflag<=2)
                        {
                                yyerrflag = 3;
                                while (yysp>0 && !(yyact(yys[yysp], 255) && yyn > 0)) yysp--;

                                if (yysp==0) return 0;
                                yystate = yyn;
                                return 1; // PARSE:
                        }
                        else
                        {
                                if (yychar==0) return 0;
                                yychar = -1;
                                return 2;
                        }
                }
		////////////////////////////////////////////////////////////////
		/// Scanner
		////////////////////////////////////////////////////////////////

		public class AToken
		{
			public int token;
			public String val;
		}

		ArrayList<AToken> TokenList = new ArrayList<AToken>();

		public boolean Scanner (String Input)
		{
		        if (Input.length() == 0) return true;
			TokenList = new ArrayList<AToken>();
			while (1==1)
			{
				AToken lasttoken = FindToken(Input);
				if (lasttoken.token == 0) break;
				if (lasttoken.token != t_ignore) TokenList.add(lasttoken);
				if (Input.length() > lasttoken.val.length())
				Input = Input.substring(lasttoken.val.length()); else return true;
			}
                   if (Output != null){
                    Output.WriteLine(Input);
			 Output.WriteLine("");
			 Output.WriteLine("No matching token found!");
                   }
                   System.out.println(Input);
			System.out.println();
			System.out.println("No matching token found!");
			return false;
		}
		public AToken FindToken (String Rest)
		{
			ArrayList<Integer> Results  = new ArrayList<Integer>();
			ArrayList<String> ResultsV = new ArrayList<String>();
                      try{

                        Pattern p;
                        Matcher m;
                      p = Pattern.compile("^(\\+)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_plus));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(\\-)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_minus));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(\\*)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_times));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(/)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_div));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(\\()");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_leftPar));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(\\))");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_rightPar));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(([a-z]|[A-Z]|_)+)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_ident));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^([0-9]+)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_number));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^([\\r\\n\\t\\s])");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_ignore));
				ResultsV.add(m.group());}

			} catch (Exception e) {}
			int maxlength = 0;
			int besttoken = 0;
			AToken ret = new AToken();
		        ret.token = besttoken;
			for (int i = 0; i < Results.size(); i++){
				if (ResultsV.get(i).toString().length() > maxlength)
				{
					maxlength = ResultsV.get(i).toString().length();
					besttoken = ((Integer)Results.get(i)).intValue();
		         	        ret.token = besttoken;
		                  	if (besttoken != 0)
			                ret.val   = ResultsV.get(i).toString();
				}
			}
			return ret;
		}


	}
