import java.io.*;
import java.util.*;
import java.util.regex.*;
class ExprLL1
{
///////////////////////////////////////////////////////////
/// Global settings: 
///////////////////////////////////////////////////////////
     int Token = 0;
     String Value = "";
     boolean SyntaxError = false;
     public static class TOutput extends PrintWriter {
      public TOutput(BufferedWriter b) { super(b); }
      public TOutput(PrintStream s) { super(s); }
      public void WriteLine(String s) { println(s); }
     }
     TOutput Output;
     int t_plus = 255;
     int t_minus = 256;
     int t_times = 257;
     int t_div = 258;
     int t_leftPar = 259;
     int t_rightPar = 260;
     int t_ident = 261;
     int t_number = 262;
     int t_ignore = 263;
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
     public static void main(String[] args) {
         ExprLL1 compiler = new ExprLL1();
         String inputstream = "";
         boolean ShowTokens = false;
         String InputFilename = "";
         String OutputFilename = "";
         for (String s : args) {
                 if (s.toLowerCase().equals("-t")) ShowTokens = true;
                 else {
                         if (InputFilename.equals(""))  InputFilename = s; else
                         if (OutputFilename.equals("")) OutputFilename = s; else
                         {
                                 System.out.println("Too many arguments!");
                                 System.exit(1);
                         }
                 }
         }
         if (InputFilename.equals("")) {
                 System.out.println("You need to specify input and outputfile: compiler.exe input.txt output.txt");
                 System.exit(1);
         }

         try{
	       FileInputStream in=new FileInputStream(InputFilename);
	       int len=in.available();
	       for(int i=1;i<=len;i++)
	       {
	          inputstream += (char)in.read();
	       }
             in.close();

             compiler.Output = null;
             if (!OutputFilename.equals(""))
             {
                 File myFile = new File(OutputFilename);
                 myFile.delete();
                 compiler.Output = new TOutput(new BufferedWriter(new FileWriter(OutputFilename)));
             }else{
                 compiler.Output = new TOutput(System.out);
             }
         }catch (Exception e) {e.printStackTrace(); System.exit(1);}
         if (!compiler.Scanner(inputstream)) System.exit(1);
         if (ShowTokens) {
                 for (Object o : compiler.TokenList) {
                         AToken t = (AToken)o;
                         System.out.println("TokenID: "+t.token+"  =  "+t.val);
                 }
         }
         compiler.NextToken(); // read first Token
         compiler.Expr();
         if (compiler.SyntaxError) System.exit(1);

         if (compiler.Output != null) compiler.Output.close();
	   System.exit(0);
     }
		////////////////////////////////////////////////////////////////
		/// Scanner
		////////////////////////////////////////////////////////////////

		public class AToken
		{
			public int token;
			public String val;
		}

		ArrayList<AToken> TokenList = new ArrayList<AToken>();

		public boolean Scanner (String Input)
		{
		        if (Input.length() == 0) return true;
			TokenList = new ArrayList<AToken>();
			while (1==1)
			{
				AToken lasttoken = FindToken(Input);
				if (lasttoken.token == 0) break;
				if (lasttoken.token != t_ignore) TokenList.add(lasttoken);
				if (Input.length() > lasttoken.val.length())
				Input = Input.substring(lasttoken.val.length()); else return true;
			}
                   if (Output != null){
                    Output.WriteLine(Input);
			 Output.WriteLine("");
			 Output.WriteLine("No matching token found!");
                   }
                   System.out.println(Input);
			System.out.println();
			System.out.println("No matching token found!");
			return false;
		}
		public AToken FindToken (String Rest)
		{
			ArrayList<Integer> Results  = new ArrayList<Integer>();
			ArrayList<String> ResultsV = new ArrayList<String>();
                      try{

                        Pattern p;
                        Matcher m;
                      p = Pattern.compile("^(\\+)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_plus));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(\\-)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_minus));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(\\*)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_times));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(/)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_div));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(\\()");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_leftPar));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(\\))");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_rightPar));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^(([a-z]|[A-Z]|_)+)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_ident));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^([0-9]+)");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_number));
				ResultsV.add(m.group());}

                      p = Pattern.compile("^([\\r\\n\\t\\s])");
                      m = p.matcher(Rest);
			if (m.find()){
				Results.add (new Integer(t_ignore));
				ResultsV.add(m.group());}

			} catch (Exception e) {}
			int maxlength = 0;
			int besttoken = 0;
			AToken ret = new AToken();
		        ret.token = besttoken;
			for (int i = 0; i < Results.size(); i++){
				if (ResultsV.get(i).toString().length() > maxlength)
				{
					maxlength = ResultsV.get(i).toString().length();
					besttoken = ((Integer)Results.get(i)).intValue();
		         	        ret.token = besttoken;
		                  	if (besttoken != 0)
			                ret.val   = ResultsV.get(i).toString();
				}
			}
			return ret;
		}


/////////////////////// Actions ///////////////////////////
     public String Action1 (String _1, String _2) {
        String __ = _2;
__ = _1 + _2;
//Output.WriteLine(__);

        return __;
     }
     public String Action2 (String _1, String _2, String _3) {
        String __ = _3;
__ = _1 + _2 + _3;

        return __;
     }
     public String Action3 (String _1, String _2, String _3) {
        String __ = _3;
__ = _1 + _2 + _3;

        return __;
     }
     public String Action4 () {
        String __ = "";
__ = "";

        return __;
     }
     public String Action5 (String _1) {
        String __ = _1;
__ = _1;

        return __;
     }
     public String Action6 (String _1) {
        String __ = _1;
__ = _1;

        return __;
     }
     public String Action7 (String _1, String _2) {
        String __ = _2;
__ = _1 + _2;

        return __;
     }
     public String Action8 (String _1, String _2, String _3) {
        String __ = _3;
__ = _1 + _2 + _3;

        return __;
     }
     public String Action9 () {
        String __ = "";
__ = "";

        return __;
     }
     public String Action10 (String _1) {
        String __ = _1;
__ = _1;

        return __;
     }
     public String Action11 (String _1) {
        String __ = _1;
__ = _1;

        return __;
     }
     public String Action12 (String _1, String _2, String _3) {
        String __ = _3;
__ = _1 + _2 + _3;

        return __;
     }
     public String Action13 (String _1) {
        String __ = _1;
__ = _1;

        return __;
     }
     public String Action14 (String _1) {
        String __ = _1;
__ = _1;

        return __;
     }
//////////////////////// Rules ////////////////////////////
     public String ReadToken(int T) {
         String current = Value;
         if (T == Token){
             NextToken();
             return current;
         }else{
             System.out.println("Syntax Error");
             SyntaxError = true;
             System.exit(1);
             return "";
         }
     }
     public void NextToken()
     {
         if(TokenList.size() == 0) {Token = 0; Value = ""; return; }
         Token = ((AToken)TokenList.get(0)).token;
         Value = ((AToken)TokenList.get(0)).val;
         TokenList.remove(0);
     }

     public String Expr () {
        if (Token == t_leftPar) { String _1 = Term();String _2 = Exp1(); return Action1(_1,_2);}
        if (Token == t_ident) { String _1 = Term();String _2 = Exp1(); return Action1(_1,_2);}
        if (Token == t_number) { String _1 = Term();String _2 = Exp1(); return Action1(_1,_2);}
        if (Token == t_plus) { String _1 = MoP();String _2 = Term();String _3 = Exp1(); return Action2(_1,_2,_3);}
        if (Token == t_minus) { String _1 = MoP();String _2 = Term();String _3 = Exp1(); return Action2(_1,_2,_3);}
        SyntaxError = true; System.exit(1); return "";
     }
     public String Exp1 () {
        if (Token == t_plus) { String _1 = MoP();String _2 = Term();String _3 = Exp1(); return Action3(_1,_2,_3);}
        if (Token == t_minus) { String _1 = MoP();String _2 = Term();String _3 = Exp1(); return Action3(_1,_2,_3);}
        return Action4();
     }
     public String MoP () {
        if (Token == t_plus) { String _1 = ReadToken(t_plus); return Action5(_1);}
        if (Token == t_minus) { String _1 = ReadToken(t_minus); return Action6(_1);}
        SyntaxError = true; System.exit(1); return "";
     }
     public String Term () {
        if (Token == t_leftPar) { String _1 = Fact();String _2 = Term1(); return Action7(_1,_2);}
        if (Token == t_ident) { String _1 = Fact();String _2 = Term1(); return Action7(_1,_2);}
        if (Token == t_number) { String _1 = Fact();String _2 = Term1(); return Action7(_1,_2);}
        SyntaxError = true; System.exit(1); return "";
     }
     public String Term1 () {
        if (Token == t_times) { String _1 = ToD();String _2 = Fact();String _3 = Term1(); return Action8(_1,_2,_3);}
        if (Token == t_div) { String _1 = ToD();String _2 = Fact();String _3 = Term1(); return Action8(_1,_2,_3);}
        return Action9();
     }
     public String ToD () {
        if (Token == t_times) { String _1 = ReadToken(t_times); return Action10(_1);}
        if (Token == t_div) { String _1 = ReadToken(t_div); return Action11(_1);}
        SyntaxError = true; System.exit(1); return "";
     }
     public String Fact () {
        if (Token == t_leftPar) { String _1 = ReadToken(t_leftPar); String _2 = Expr();String _3 = ReadToken(t_rightPar); return Action12(_1,_2,_3);}
        if (Token == t_ident) { String _1 = ReadToken(t_ident); return Action13(_1);}
        if (Token == t_number) { String _1 = ReadToken(t_number); return Action14(_1);}
        SyntaxError = true; System.exit(1); return "";
     }
}
