public class InPostfix {
  // Umwandlung Infix in Postfix-Ausdruck

  static int prioritt (char operator) {
    if (operator == '+') return 1;
    if (operator == '*') return 2;
    return 0;
    } // Ende prioritt

  public static void main (String[] eingabe) {
    String eingabewort = "(2+3)*4";
    if (eingabe.length > 0)
      eingabewort = eingabe[0];
    Zeichenstapel stapel = new Zeichenstapel(20);
    String postfix = "";
    for (int i = 0; i < eingabewort.length(); i++) {
      char zeichen = eingabewort.charAt(i);
      if (Character.isDigit(zeichen))
        postfix += zeichen;
      else if (zeichen == '(')
        stapel.legeAuf(zeichen);
      else if (zeichen == ')') {
        while (stapel.liesSpitze() != '(')
          postfix += stapel.holeVon();
        stapel.holeVon(); // ffnende Klammer "entsorgen"
        } // Ende else
      else {
        while (! stapel.istLeer() &&
               stapel.liesSpitze() != '(' &&
               prioritt(zeichen) <=
               prioritt(stapel.liesSpitze()))
          postfix += stapel.holeVon();
        stapel.legeAuf(zeichen);
        } // Ende else
      } // Ende for
    while (! stapel.istLeer())
      postfix += stapel.holeVon();
    System.out.println("\n " + postfix);
    } // Ende main

  } // Ende InPostfix

class Zeichenstapel {
  // Implementation mittels Reihung

  int    maxLnge;
  char[] reihung;
  int    spitze;
  
  Zeichenstapel (int m) {
    maxLnge = m;
    reihung = new char[maxLnge];
    spitze = -1;
    } // Ende Konstruktor

  boolean istLeer()
    {return spitze == -1;}

  boolean istVoll()
    {return spitze == maxLnge - 1;}

  void legeAuf (char zeichen) {
    if (! istVoll())
      reihung[++spitze] = zeichen;
    } // Ende legeAuf

  char holeVon() {
    if (istLeer()) return '0';
    return reihung[spitze--];
    } // Ende holeVon

  char liesSpitze()
    {return reihung[spitze];}
 
  } // Ende Zeichenstapel

